﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;

namespace tietokannat
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        tietokannat.tietokannat2DataSet tietokannat2DataSet;
        System.Windows.Data.CollectionViewSource reseptiViewSource;
        System.Windows.Data.CollectionViewSource reseptiOhjeViewSource;
        tietokannat.tietokannat2DataSetTableAdapters.ReseptiTableAdapter tietokannat2DataSetReseptiTableAdapter;
        tietokannat.tietokannat2DataSetTableAdapters.OhjeTableAdapter tietokannat2DataSetOhjeTableAdapter;
        
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

            tietokannat2DataSet = ((tietokannat.tietokannat2DataSet)(this.FindResource("tietokannat2DataSet")));
            // Load data into the table Resepti. You can modify this code as needed.
            tietokannat2DataSetReseptiTableAdapter = new tietokannat.tietokannat2DataSetTableAdapters.ReseptiTableAdapter();
            reseptiViewSource = ((System.Windows.Data.CollectionViewSource)(FindResource("reseptiViewSource")));
            tietokannat2DataSetReseptiTableAdapter.Fill(tietokannat2DataSet.Resepti);
            reseptiViewSource.View.MoveCurrentToFirst();
            // Load data into the table Ohje. You can modify this code as needed.
            tietokannat2DataSetOhjeTableAdapter = new tietokannat.tietokannat2DataSetTableAdapters.OhjeTableAdapter();
            reseptiOhjeViewSource = ((System.Windows.Data.CollectionViewSource)(FindResource("reseptiOhjeViewSource")));
            tietokannat2DataSetOhjeTableAdapter.Fill(tietokannat2DataSet.Ohje);
            reseptiOhjeViewSource.View.MoveCurrentToFirst();
        }

        private void buttonPrev_Click(object sender, RoutedEventArgs e)
        {
            reseptiViewSource.View.MoveCurrentToPrevious();
                    }

        private void buttonNext_Click(object sender, RoutedEventArgs e)
        {
            reseptiViewSource.View.MoveCurrentToNext();
        }

        private void buttonUusi_Click(object sender, RoutedEventArgs e)
        {
            DataRow resepti = tietokannat2DataSet.Resepti.NewReseptiRow();
            resepti.SetField("Nimi", "Hernesoppa");
            resepti.SetField("RuokaLajiID", 1);
            resepti.SetField("Kuvaus", "kansallisherkku");
            resepti.SetField("Henkilomaara", 1);
            tietokannat2DataSet.Resepti.Rows.Add(resepti);
            tietokannat2DataSetReseptiTableAdapter.Update(resepti);

//                .UpdateAll(tietokannat2DataSet);
        }

        private void buttonPoista_Click(object sender, RoutedEventArgs e)
        {
            // tämä ei toimi jos reseptiin liittyy ohjeita vaan liittyvät ohjeet pitäisi poistaa ensin
            // tämä on tehtävä ehdottomasti transaktion sisällä. Toinen vaihtoehto on muokata tietokannan rakennetta
            // ja sallia vyöryvät poistot (cascade)
            tietokannat2DataSetReseptiTableAdapter.Update(tietokannat2DataSet.Resepti);
            tietokannat2DataSet.Resepti.Rows[reseptiViewSource.View.CurrentPosition].Delete();
            //            tietokannat2DataSet.AcceptChanges();
        }

        private void buttonTallenna_Click(object sender, RoutedEventArgs e)
        {
            tietokannat2DataSetReseptiTableAdapter.Update(tietokannat2DataSet.Resepti);
            tietokannat2DataSetOhjeTableAdapter.Update(tietokannat2DataSet.Ohje);
        }
    }
}
